> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Verify CSR phone number coverage

> Verify the coverage for a list of phone numbers.



## OpenAPI

````yaml /openapi/source/external/porting/customer_service_record.json post /customer_service_records/phone_number_coverages
openapi: 3.1.0
info:
  version: 2.0.0
  title: Telnyx API
  x-latency-category: responsive
  description: SIP trunking, SMS, MMS, Call Control and Telephony Data Services.
  license:
    name: MIT
    url: https://github.com/openai/openai-openapi/blob/master/LICENSE
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
    description: Version 2.0.0 of the Telnyx API
security:
  - bearerAuth: []
tags:
  - name: Customer Service Record
    description: Customer Service Record operations
  - name: Callbacks
    description: Callbacks
paths:
  /customer_service_records/phone_number_coverages:
    post:
      tags:
        - Customer Service Record
      summary: Verify CSR phone number coverage
      description: Verify the coverage for a list of phone numbers.
      operationId: VerifyPhoneNumberCoverage
      requestBody:
        $ref: >-
          #/components/requestBodies/VerifyCustomerServiceRecordPhoneNumberCoverage
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: array
                    items:
                      $ref: >-
                        #/components/schemas/CustomerServiceRecordPhoneNumberCoverage
        '401':
          $ref: '#/components/responses/UnauthorizedErrorResponse'
        '403':
          $ref: '#/components/responses/ForbiddenErrorResponse'
        '422':
          $ref: '#/components/responses/UnprocessableEntityErrorResponse'
        '500':
          $ref: '#/components/responses/UnexpectedErrorResponse'
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Telnyx from 'telnyx';


            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });


            const response = await
            client.customerServiceRecords.verifyPhoneNumberCoverage({
              phone_numbers: ['+13035553000'],
            });


            console.log(response.data);
        - lang: Python
          source: >
            import os

            from telnyx import Telnyx


            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )

            response =
            client.customer_service_records.verify_phone_number_coverage(
                phone_numbers=["+13035553000"],
            )

            print(response.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tresponse, err := client.CustomerServiceRecords.VerifyPhoneNumberCoverage(context.TODO(), telnyx.CustomerServiceRecordVerifyPhoneNumberCoverageParams{\n\t\tPhoneNumbers: []string{\"+13035553000\"},\n\t})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", response.Data)\n}\n"
        - lang: Java
          source: >-
            package com.telnyx.sdk.example;


            import com.telnyx.sdk.client.TelnyxClient;

            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;

            import
            com.telnyx.sdk.models.customerservicerecords.CustomerServiceRecordVerifyPhoneNumberCoverageParams;

            import
            com.telnyx.sdk.models.customerservicerecords.CustomerServiceRecordVerifyPhoneNumberCoverageResponse;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    CustomerServiceRecordVerifyPhoneNumberCoverageParams params = CustomerServiceRecordVerifyPhoneNumberCoverageParams.builder()
                        .addPhoneNumber("+13035553000")
                        .build();
                    CustomerServiceRecordVerifyPhoneNumberCoverageResponse response = client.customerServiceRecords().verifyPhoneNumberCoverage(params);
                }
            }
        - lang: Ruby
          source: >-
            require "telnyx"


            telnyx = Telnyx::Client.new(api_key: "My API Key")


            response =
            telnyx.customer_service_records.verify_phone_number_coverage(phone_numbers:
            ["+13035553000"])


            puts(response)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Telnyx\Client;

            use Telnyx\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API
            Key');


            try {
              $response = $client->customerServiceRecords->verifyPhoneNumberCoverage(
                phoneNumbers: ['+13035553000']
              );

              var_dump($response);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: CLI
          source: |-
            telnyx customer-service-records verify-phone-number-coverage \
              --api-key 'My API Key' \
              --phone-number "'+13035553000'"
components:
  requestBodies:
    VerifyCustomerServiceRecordPhoneNumberCoverage:
      required: true
      content:
        application/json:
          schema:
            type: object
            required:
              - phone_numbers
            properties:
              phone_numbers:
                type: array
                description: The phone numbers list to be verified.
                items:
                  type: string
                  description: A valid US phone number in E164 format.
                  example: '+13035553000'
                  pattern: ^\+1\d{10}$
  schemas:
    CustomerServiceRecordPhoneNumberCoverage:
      type: object
      properties:
        phone_number:
          type: string
          description: The phone number that is being verified.
          example: '+12223334444'
        has_csr_coverage:
          type: boolean
          description: Indicates whether the phone number is covered or not.
          example: true
        reason:
          type: string
          description: >-
            The reason why the phone number is not covered. Only returned if
            `has_csr_coverage` is false.
          example: The phone number '+19999999999' is invalid.
        additional_data_required:
          type: array
          description: >-
            Additional data required to perform CSR for the phone number. Only
            returned if `has_csr_coverage` is true.
          items:
            type: string
            enum:
              - name
              - authorized_person_name
              - account_number
              - customer_code
              - pin
              - address_line_1
              - city
              - state
              - zip_code
              - billing_phone_number
            example: name
        record_type:
          type: string
          description: Identifies the type of the resource.
          example: customer_service_record_phone_number_coverage
    UnauthorizedError:
      allOf:
        - $ref: '#/components/schemas/GenericError'
        - properties:
            code:
              example: '10009'
              type: string
            title:
              example: Authentication failed
              type: string
            detail:
              example: >-
                The required authentication headers were either invalid or not
                included in the request.
              type: string
            meta:
              type: object
              properties:
                url:
                  type: string
                  example: https://developers.telnyx.com/docs/overview/errors/10009
          type: object
    ForbiddenError:
      allOf:
        - $ref: '#/components/schemas/GenericError'
        - properties:
            code:
              example: '10010'
              type: string
            title:
              example: Authorization failed
              type: string
            detail:
              example: >-
                You do not have permission to perform the requested action on
                the specified resource or resources.
              type: string
            meta:
              type: object
              properties:
                url:
                  type: string
                  example: https://developers.telnyx.com/docs/overview/errors/10010
          type: object
    UnprocessableEntityError:
      allOf:
        - $ref: '#/components/schemas/GenericError'
        - properties:
            code:
              example: '10002'
              type: string
            title:
              example: Invalid phone number
              type: string
            detail:
              example: The phone number is invalid.
              type: string
            source:
              type: object
              properties:
                pointer:
                  type: string
                  example: /phone_numbers
            meta:
              type: object
              properties:
                url:
                  type: string
                  example: https://developers.telnyx.com/docs/overview/errors/10002
          type: object
    UnexpectedError:
      allOf:
        - $ref: '#/components/schemas/GenericError'
        - properties:
            code:
              example: '10007'
              type: string
            title:
              example: Unexpected error
              type: string
            detail:
              example: An unexpected error occurred.
              type: string
            meta:
              type: object
              properties:
                url:
                  type: string
                  example: https://developers.telnyx.com/docs/overview/errors/10007
          type: object
    GenericError:
      properties:
        code:
          type: string
        title:
          type: string
        detail:
          type: string
        source:
          type: object
          properties:
            pointer:
              description: JSON pointer (RFC6901) to the offending entity.
              type: string
            parameter:
              description: Indicates which query parameter caused the error.
              type: string
        meta:
          type: object
          additionalProperties: true
      type: object
  responses:
    UnauthorizedErrorResponse:
      description: >-
        The required authentication headers were either invalid or not included
        in the request.
      content:
        application/json:
          schema:
            properties:
              errors:
                type: array
                items:
                  $ref: '#/components/schemas/UnauthorizedError'
    ForbiddenErrorResponse:
      description: >-
        You do not have permission to perform the requested action on the
        specified resource or resources.
      content:
        application/json:
          schema:
            properties:
              errors:
                type: array
                items:
                  $ref: '#/components/schemas/ForbiddenError'
    UnprocessableEntityErrorResponse:
      description: Unprocessable entity. Check the 'detail' field in response for details.
      content:
        application/json:
          schema:
            properties:
              errors:
                type: array
                items:
                  $ref: '#/components/schemas/UnprocessableEntityError'
    UnexpectedErrorResponse:
      description: An unexpected error occurred.
      content:
        application/json:
          schema:
            properties:
              errors:
                type: array
                items:
                  $ref: '#/components/schemas/UnexpectedError'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````